﻿using System;
using System.Diagnostics;
using System.IO;
using System.Reflection;
using System.Runtime.InteropServices;
using System.Windows.Forms;

namespace time
{
    public partial class Form1 : Form
    {
        private Stopwatch _stopWatch=new Stopwatch();
        public Form1()
        {
            InitializeComponent();
            this.Text = Path.GetFileNameWithoutExtension(Application.ExecutablePath);
            SetHook();
        }
        
        private void timer1_Tick(object sender, EventArgs e)
        {
            //label1.Text = string.Format("{0:00}:{1:00}:{2:00}", _stopWatch.Elapsed.Minutes,_stopWatch.Elapsed.Seconds, _stopWatch.Elapsed.Milliseconds);
            label1.Text = _stopWatch.Elapsed.ToString(@"hh\:mm\:ss\.ff");
        }

        private void btnStart_Click(object sender, EventArgs e)
        {
            if (timer1.Enabled == true)
            {
                timer1.Enabled = false;
                _stopWatch.Stop();
            }
            else
            {
                timer1.Enabled = true;
                _stopWatch.Start();
            }
        }

        private void btnStop_Click(object sender, EventArgs e)
        {
            timer1.Enabled = false;
            _stopWatch.Reset();
            label1.Text = "00:00:00.00";
        }

        // HOOK
        private const int WH_KEYBOARD_LL = 13;
        private LowLevelKeyboardProcDelegate m_callback;
        private IntPtr m_hHook;
        [DllImport("user32.dll", SetLastError = true)]
        private static extern IntPtr SetWindowsHookEx(
            int idHook,
            LowLevelKeyboardProcDelegate lpfn,
            IntPtr hMod, int dwThreadId);
        [DllImport("user32.dll", SetLastError = true)]
        private static extern bool UnhookWindowsHookEx(IntPtr hhk);
        [DllImport("Kernel32.dll", SetLastError = true)]
        private static extern IntPtr GetModuleHandle(IntPtr lpModuleName);
        [DllImport("user32.dll", SetLastError = true)]
        private static extern IntPtr CallNextHookEx(
            IntPtr hhk,
            int nCode, IntPtr wParam, IntPtr lParam);
        private IntPtr LowLevelKeyboardHookProc(int nCode, IntPtr wParam, IntPtr lParam)
        {
            if (nCode < 0)
            {
                return CallNextHookEx(m_hHook, nCode, wParam, lParam);
            }
            else
            {
                var khs = (KeyboardHookStruct)
                          Marshal.PtrToStructure(lParam,
                          typeof(KeyboardHookStruct));
                // https://i-msdn.sec.s-msft.com/dynimg/IC53379.gif
                if (wParam.ToInt32() == 260 && khs.ScanCode == 2) //alt+1 
                {
                    if (timer1.Enabled == true)
                    {
                        timer1.Enabled = false;
                        _stopWatch.Stop();
                    }
                    else
                    {
                        timer1.Enabled = true;
                        _stopWatch.Start();
                    }
                    IntPtr val = new IntPtr(1);
                    return val;
                }
                else if (wParam.ToInt32() == 260 && khs.ScanCode == 3) //alt+2 
                {

                    timer1.Enabled = false;
                    _stopWatch.Reset();
                    label1.Text = "00:00:00.00";

                    IntPtr val = new IntPtr(1);
                    return val;
                }
                else
                {
                    return CallNextHookEx(m_hHook, nCode, wParam, lParam);
                }
            }
        }
        [StructLayout(LayoutKind.Sequential)]
        private struct KeyboardHookStruct
        {
            public readonly int VirtualKeyCode;
            public readonly int ScanCode;
            public readonly int Flags;
            public readonly int Time;
            public readonly IntPtr ExtraInfo;
        }
        private delegate IntPtr LowLevelKeyboardProcDelegate(
            int nCode, IntPtr wParam, IntPtr lParam);
        public void SetHook()
        {
            m_callback = LowLevelKeyboardHookProc;
            m_hHook = SetWindowsHookEx(WH_KEYBOARD_LL,
                m_callback,
                GetModuleHandle(IntPtr.Zero), 0);
        }
        public void Unhook()
        {
            UnhookWindowsHookEx(m_hHook);
        }
    }
}
